/*
 * module3.c
 * Basic demo program for second DSP in 3 DSP HERON-API example.
 *
 *     PW    ver 2.0    30-3-00   changed for heron_api v2.3
 *     PW    ver 3.0    17-7-00   changed for CCS 1.2
 */

#include <stdio.h>
#include "heron1.h"
#include <std.h>

/* YOU need to set this value to reflect how your module is connected
to the second module. */
#define FIFONO	0	/* FIFO through which module communicates with the first module */


main()
{
}  



void maintask(void)
{
	
	HeronFIFO *rfifo;
	HeronFIFO *wfifo;
	int status;
	int data;
	int pattern[32];
	/*
	 * All processors in the system are required to clear the config line
	 * to an in-active state. One all processors in a system performed a
	 * HeronConfigOff(), the config line goes in-active, and GDIO modules
	 * are only then able to send data onto C6xxx modules. 
	 * If you only use processor modules but no GDIO modules, then this
	 * doesn't matter to you and you can leave the config line in any
	 * state (active -> don't do a HeronConfigOff() or in-active -> do a
	 * HeronConfigOff() 
	 */
     HeronConfigOff();     
        
	printf("Third HERON module has started running\n");

/* open the FIFO for reading*/
    rfifo=HeronOpenFifo(FIFONO,"r");
    if (rfifo==NULL)
     {
     printf("Cannot open fifo %d for read. Error %d\n",FIFONO,heronerr);
     exit(-1); 	       
     }
/* open the FIFO for writing*/
    wfifo=HeronOpenFifo(FIFONO,"w");
    if (wfifo==NULL)
     {
     printf("Cannot open fifo %d for write. Error %d\n",FIFONO,heronerr);
     exit(-1); 	
     } 

	
/* send a word to the first DSP */
	data = 0x3;
  	status = HeronWrite(wfifo,&data,1);
	if (status == HERON_IO_IN_PROGRESS)
	{
	status = HeronWaitIo(wfifo);
	}
	if (status != HERON_OK) 
	{
	printf("Cannot write fifo %d. Error %d\n",FIFONO,heronerr);
	exit(-1);
	}

/* read a pattern from the second DSP */
  	status = HeronRead(rfifo,pattern,32);
	if (status == HERON_IO_IN_PROGRESS)
	{
	status = HeronWaitIo(rfifo);
	}
	if (status != HERON_OK) 
	{
	printf("Cannot read fifo %d. Error %d\n",FIFONO,heronerr);
	exit(-1);
	}
	
/* send the received pattern back to the second DSP */

  	status = HeronWrite(wfifo,pattern,32);
	if (status == HERON_IO_IN_PROGRESS)
	{
	status = HeronWaitIo(wfifo);
	}
	if (status != HERON_OK) 
	{
	printf("Cannot write fifo %d. Error %d\n",FIFONO,heronerr);
	exit(-1);
	}

/* close the fifos*/
	status = HeronClose(rfifo);
	if (status != HERON_OK)
	{
	printf(" Error closing read fifo \n");
	exit(-1);
	}
	status = HeronClose(wfifo);
	if (status != HERON_OK)
	{
	printf(" Error closing write fifo \n");
	exit(-1);
	}



	while (1) {}            /* No real purpose, just for tracking */
}
/*** End Of File ***/
